unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Encoding, Grids, ComCtrls, Generics.Collections,
  DBGrids, ExtCtrls, Math, ShellApi, Menus;

type
  TForm3 = class(TForm)
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    BitBtn2: TBitBtn;
    SaveDialog1: TSaveDialog;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Edit1: TEdit;
    Label2: TLabel;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    Memo1: TMemo;
    BitBtn10: TBitBtn;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    Label4: TLabel;
    Label5: TLabel;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    PopupMenu1: TPopupMenu;
    Selectall1: TMenuItem;
    Copytoclipboard1: TMenuItem;
    Label6: TLabel;
    CheckBox3: TCheckBox;
    Label7: TLabel;
    StringGrid1: TStringGrid;
    BitBtn13: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure StringGrid1EndDock(Sender, Target: TObject; X, Y: Integer);
    procedure BitBtn5Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);
    procedure BitBtn11Click(Sender: TObject);
    procedure BitBtn12Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure Copytoclipboard1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure BitBtn13Click(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    procedure WMDropFiles(var Msg: TWMDropFiles);
    message WM_DROPFILES;
  public
    { Public declarations }
  end;

type
  tDic = array [0 .. 5] of string;

type
  mDic = array [0 .. 1] of Integer;

type
  words = array of Word;

type
  dwords = array of dword;

var
  Form3: TForm3;
  FSm: TFileStream;
  FS: TMemoryStream;
  NamesArray: TDictionary<longint, string>;
  dicM: TDictionary<dword, mDic>;
  dicT: TDictionary<Integer, tDic>;
  dicRloc: TDictionary<longint, words>;
  dicDataRloc: TDictionary<longint, words>;
  dicImp: TDictionary<dword, dwords>;
  romstart: dword;

  sgsel: TStringList;

implementation

{$R *.dfm}

procedure TForm3.CheckBox1Click(Sender: TObject);
begin
  showmessage(inttostr(StringGrid1.Row));
end;

procedure TForm3.Copytoclipboard1Click(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

procedure GridSort(SG: TStringGrid; ByColNumber, FromRow, ToRow: Integer);
var
  Temp: TStringList;

  procedure QuickSort(Lo, Hi: Integer; CC: TStrings);

    procedure Sort(l, r: Integer);
    var
      i, j: Integer;
      X: string;
    begin
      i := l;
      j := r;
      X := CC[(l + r) DIV 2];
      repeat
        while CC[i] < X do
          inc(i);
        while X < CC[j] do
          dec(j);
        if i <= j then
        begin
          Temp.Assign(SG.Rows[j]); //   2 
          SG.Rows[i].BeginUpdate;
          SG.Rows[j].BeginUpdate;

          SG.Rows[j].Assign(SG.Rows[i]);
          SG.Rows[i].Assign(Temp);

          SG.Rows[i].EndUpdate;
          SG.Rows[j].EndUpdate;

          inc(i);
          dec(j);
        end;
      until i > j;
      if l < j then
        Sort(l, j);
      if i < r then
        Sort(i, r);
    end;

  begin { quicksort } ;
    Sort(Lo, Hi);
  end;

begin
  Temp := TStringList.Create;
  QuickSort(FromRow, ToRow, SG.Cols[ByColNumber]);
  Temp.Free;
end;

function RomToOffset(addr: dword): dword;
begin
  //Result := addr - (addr shr 28) * $10000000;
  // Result := addr and $7fffffff;
  Result := addr - romstart;
end;

function RomToOffsetBase(addr: dword): dword;
begin
  Result := (addr shr 28) * $10000000;
  // Result := addr and $80000000;
end;

procedure LoadDump(path: string);
var
  start, headlen, filesize, fileaddr, signature: dword;
  i, buf: longint;
  len: byte;
  Buffer: TBytes;
  Encoding: TEncoding;

begin
  Form3.OpenDialog1.FileName := path;
  Form3.StringGrid1.Visible := False;

  Form3.StringGrid1EndDock(nil, nil, 0, 0);
  // FS := TFileStream.Create(path, fmOpenRead or fmShareDenyNone);
  FS := TMemoryStream.Create;
  FS.LoadFromFile(path);

  FS.Seek($8C, 0);
  FS.Read(romstart, 4);
  FS.Seek(4, 1);
  FS.Seek($A0, 0);
  FS.Read(start, 4);
  start := RomToOffset(start) - 4;
//  showmessage(inttohex(start, 8));
  FS.Seek(start, 0);

  FS.Read(headlen, 4);
  start := FS.Position;
  Encoding := TEncoding.Unicode;

  i := 0;
  while FS.Position - start < headlen do
  begin
    FS.Read(filesize, 4);
    FS.Read(fileaddr, 4);
    FS.Seek(1, 1);
    FS.Read(len, 1);
    SetLength(Buffer, len * 2);
    FS.Read(Buffer[0], len * 2);
    buf := FS.Position;
    FS.Seek(RomToOffset(fileaddr) + $10, 0);
    FS.Read(signature, 4);
    FS.Position := buf;
    if (signature <> $434F5045) and (RomToOffset(fileaddr) < FS.Size) and
      (RomToOffset(fileaddr) + filesize + $78 < FS.Size + 2) then
    begin
      Form3.StringGrid1.Rows[Form3.StringGrid1.RowCount - 1][0] := ' ';
      Form3.StringGrid1.Rows[Form3.StringGrid1.RowCount - 1][1] := LowerCase
        (Encoding.GetString(Buffer));
      Form3.StringGrid1.Rows[Form3.StringGrid1.RowCount - 1][2] := inttohex
        (filesize, 8);
      Form3.StringGrid1.Rows[Form3.StringGrid1.RowCount - 1][3] := inttohex(
        { RomToOffset( } fileaddr, 8);
      Form3.StringGrid1.RowCount := Form3.StringGrid1.RowCount + 1;
    end;
    if FS.Position mod 4 <> 0 then
      FS.Seek(2, 1);
    inc(i);
    if i = 200 then
    begin
      Application.Processmessages;
      i := 0;
    end;
  end;
  FS.Seek(0, 0);
  Form3.StringGrid1.RowCount := Form3.StringGrid1.RowCount - 1;
  GridSort(Form3.StringGrid1, 1, 1, Form3.StringGrid1.RowCount - 1);

  Form3.StringGrid1.Visible := True;

  Form3.BitBtn2.Enabled := True;
  Form3.BitBtn3.Enabled := True;
  Form3.BitBtn4.Enabled := True;
end;

procedure Delay(Milliseconds: Integer);
{ by Hagen Reddmann }
var
  Tick: dword;
  Event: THandle;
begin
  Event := CreateEvent(nil, False, False, nil);
  try
    Tick := GetTickCount + dword(Milliseconds);
    while (Milliseconds > 0) and (MsgWaitForMultipleObjects(1, Event, False,
        Milliseconds, QS_ALLINPUT) <> WAIT_TIMEOUT) do
    begin
      Application.Processmessages;
      Milliseconds := Tick - GetTickCount;
    end;
  finally
    CloseHandle(Event);
  end;
end;

procedure SaveFile(path: string; num: Integer);
var
  SB: TFileStream;
  Size: longint;
begin
  SB := TFileStream.Create(path, fmOpenWrite or fmCreate);
  FS.Seek(RomToOffset(StrToInt('$' + Form3.StringGrid1.Rows[num][3])), 0);
  Size := $78 + StrToInt('$' + Form3.StringGrid1.Rows[num][2]);
  if FS.Position + Size < FS.Size then
    SB.CopyFrom(FS, Size);
  SB.Free;
end;

procedure WriteBytes(bytes: TBytes; val: dword);
var
  i, oldlen: Integer;
begin
  oldlen := Length(bytes);
  SetLength(bytes, Length(bytes) + SizeOf(val));
  for i := 1 to SizeOf(val) do
    bytes[oldlen + i] := val and (i * $100 * $FF) div (i * $100);
end;

procedure TForm3.BitBtn10Click(Sender: TObject);
begin
  StringGrid1.Height := ClientHeight - 47;
  StringGrid1.Anchors := StringGrid1.Anchors + [akBottom];
  Memo1.Visible := False;
  BitBtn10.Visible := False;
  BitBtn12.Visible := False;
end;

procedure TForm3.BitBtn11Click(Sender: TObject);
var
  Size, i, k, len: longint;
  buf, expnum, expdir: dword;
  name, expnames: string;
  Relations: TStringList;
  implist: TStringList;
  exptable, explist: array of string;
  dic: mDic;
begin

  BitBtn11.Caption := 'Processing...';
  BitBtn11.Enabled := False;

  BitBtn1.Enabled := False;
  BitBtn2.Enabled := False;
  BitBtn6.Enabled := False;
  BitBtn5.Enabled := False;
  BitBtn7.Enabled := False;
  BitBtn9.Enabled := False;

  Memo1.Lines.Clear;

  Relations := TStringList.Create;
  Relations.Add('XIP linking for ' + StringGrid1.Rows[StringGrid1.Row][1]);
  Relations.Add(Format('Start 0x%s - end 0x%s',
      [StringGrid1.Rows[StringGrid1.Row][3], inttohex
        (StrToInt('$' + StringGrid1.Rows[StringGrid1.Row][2]) + StrToInt
          ('$' + StringGrid1.Rows[StringGrid1.Row][3]), 8)]));
  Relations.Add('');
  // showmessage('pass 0');

  // FPS:=TMemoryStream.Create;
  // FS.Seek(0,0);
  // FPS.CopyFrom(FS, FS.Size);
  // FPS.Seek(0,0);

  FS.Seek(RomToOffset(StrToInt('$' + StringGrid1.Rows[StringGrid1.Row][3])), 0);
  FS.Seek($3C, 1);
  FS.Read(expnum, 4);
  FS.Read(expdir, 4);

  SetLength(exptable, expnum);
  SetLength(explist, expnum);

  // explist := TStringList.Create;
  // explist.Sorted := true;
  implist := TStringList.Create;
  // implist.Sorted := true;

  if expnum > 0 then
  begin
    FS.Seek(RomToOffset(expdir), 0);
    for i := 1 to expnum do
    begin
      FS.Read(buf, 4);
      exptable[i - 1] := inttohex(buf, 8);
    end;

    // showmessage('pass 1');
    if expnum > 0 then
      for i := 1 to StringGrid1.RowCount - 1 do
      begin
        FS.Seek(RomToOffset(StrToInt('$' + StringGrid1.Rows[i][3])), 0);
        Size := StrToInt('$' + StringGrid1.Rows[i][2]);
        len := FS.Position + Size;
        Application.Processmessages;

        BitBtn11.Caption := Format('Processing [%d/%d] ...',
          [i, StringGrid1.RowCount - 1]);

        while (FS.Position < len) and (FS.Position < FS.Size) do
        begin
          FS.Read(buf, 4);
          // inc(len, 4);
          if buf = $E51FF004 then
          begin
            // inc(len, 4);
            FS.Read(buf, 4);
            for k := 0 to expnum - 1 do
              if (buf <> 0) and (exptable[k] = inttohex(buf, 8)) and
                (Pos(StringGrid1.Rows[i][1], explist[k]) = 0) then
              begin
                explist[k] := explist[k] + ' ' + StringGrid1.Rows[i][1];
                if Pos(StringGrid1.Rows[i][1], expnames) = 0 then
                  expnames := expnames + StringGrid1.Rows[i][1] + ' ';
                break;
              end;
            // explist.Values[inttohex(buf, 8)] := explist.Values[inttohex(buf, 8)] + ' ' + StringGrid1.Rows[i][1];
          end;
        end;
      end;
  end;

  // showmessage('pass 2');

  FS.Seek(RomToOffset(StrToInt('$' + StringGrid1.Rows[StringGrid1.Row][3])), 0);
  Size := StrToInt('$' + StringGrid1.Rows[StringGrid1.Row][2]);
  len := FS.Position + Size + $78;

  // showmessage('pass 3');
  Size := 0;
  while (FS.Position < len) and (FS.Position < FS.Size) do
  begin
    FS.Read(buf, 4);
    if buf = $E51FF004 then
    begin
      FS.Read(buf, 4);
      if dicM.TryGetValue(buf, dic) then
        implist.Values[StringGrid1.Rows[dic[0]][1]] := implist.Values
          [StringGrid1.Rows[dic[0]][1]] + Format
          ('%4d:%s', [dic[1], inttohex(buf, 8)]) + ' ';
      inc(Size);
    end;
  end;

  // FPS.Free;

  // showmessage('pass 4');
  Relations.Add(Format('File used %d times by: %s',
      [StrToInt('$' + StringGrid1.Rows[StringGrid1.Row][4]), expnames]));
  for i := 0 to Length(exptable) - 1 do
    Relations.Add(Format('%4d 0x%s %s', [i + 1, exptable[i], explist[i]]));
  Relations.Add('');
  Relations.Add(Format('File imports %d functions from %d libraries:',
      [Size, implist.Count]));
  for name in implist do
    Relations.Add('from ' + StringReplace(name, '=', #$0d#$0a#$20#$20#$20#$20,
        [rfReplaceAll]));

  if CheckBox3.Checked then
  begin
    Memo1.Lines := Relations;
    StringGrid1.Height := 129;
    StringGrid1.Anchors := StringGrid1.Anchors - [akBottom];
    StringGrid1.TopRow := StringGrid1.Row;
    Memo1.Visible := True;

    BitBtn10.Visible := True;
    BitBtn12.Visible := True;
  end;

  Relations.SaveToFile(ExtractFilePath(OpenDialog1.FileName) + StringReplace
      (StringGrid1.Rows[StringGrid1.Row][1] + '_LINKS_' + TimeToStr(now)
        + '.log', ':', '.', [rfReplaceAll]));

  BitBtn1.Enabled := True;
  BitBtn2.Enabled := True;
  BitBtn6.Enabled := True;
  BitBtn5.Enabled := True;
  BitBtn7.Enabled := True;
  BitBtn9.Enabled := True;

  BitBtn11.Enabled := True;
  BitBtn11.Caption := 'Done!';
  Delay(3000);
  BitBtn11.Caption := 'Show links';

  Relations.Free;
  implist.Free;
  SetLength(explist, 0);
  SetLength(exptable, 0);

end;

procedure TForm3.BitBtn12Click(Sender: TObject);
begin
  SaveDialog1.FileName := 'aRomAT.log';
  if SaveDialog1.Execute then
    Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm3.BitBtn13Click(Sender: TObject);
var
  s: string;
begin
  for s in sgsel do
    StringGrid1.Cells[0, StrToInt(s)] := ' ';
  StringGrid1.Repaint;
  sgsel.Clear;
  BitBtn3.Visible := False;
end;

procedure TForm3.BitBtn1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    LoadDump(OpenDialog1.FileName);
    BitBtn4Click(nil);
    BitBtn3Click(nil);
    BitBtn8Click(nil);
    StringGrid1.SetFocus;
  end;
end;

procedure TForm3.BitBtn2Click(Sender: TObject);
var
  s: string;
begin
  SaveDialog1.FileName := StringGrid1.Rows[StringGrid1.Row][1];
  if SaveDialog1.Execute then
  begin
    if sgsel.Count = 0 then
      SaveFile(SaveDialog1.FileName, StringGrid1.Row)
    else
      for s in sgsel do
        SaveFile(ExtractFilePath(SaveDialog1.FileName) + StringGrid1.Rows
            [StrToInt(s)][1], StrToInt(s));

    Form3.BitBtn2.Caption := 'Done!';
    Delay(3000);
    Form3.BitBtn2.Caption := 'Extract selected';
  end;
end;

procedure TForm3.BitBtn3Click(Sender: TObject);
begin
  BitBtn3.Enabled := False;
  if GetFileAttributes(PChar(ExtractFilePath(Application.Exename) + 'dso'))
    = FILE_ATTRIBUTE_DIRECTORY then
  begin
    BitBtn3.Font.Color := clGreen;
    BitBtn3.Kind := bkOk;
    BitBtn3.Caption := 'Dso folder ready';
    BitBtn3.Font.Style := [];
  end
  else
  begin
    BitBtn3.Font.Color := clRed;
    BitBtn3.Kind := bkNo;
    BitBtn3.Caption := 'Please check dso!';
    BitBtn3.Enabled := True;
    BitBtn3.Font.Style := [fsBold];
  end;
end;

procedure TForm3.BitBtn4Click(Sender: TObject);
var
  i, j, k: longint;
  expnum, expaddr, bufexp, dsosize, dsostart: dword;
  fDso: TFileStream;
  sDso: TStringList;
  fname, dname, dsotemp: string;
  Temp: TBytes;
  b: byte;
  dic: mDic;
begin

  BitBtn4.Enabled := False;

  Application.Processmessages;
  for i := 1 to StringGrid1.RowCount - 1 do
  begin
    FS.Seek(RomToOffset($3C + StrToInt('$' + StringGrid1.Rows[i][3])), 0);
    FS.Read(expnum, 4);
    FS.Read(expaddr, 4);
    if expnum > 0 then
    begin
      fname := StringGrid1.Rows[i][1];
      dname := ExtractFilePath(Application.Exename) + 'dso\' + Copy
        (fname, 0, Length(fname) - 4) + '.dso';
      sDso := TStringList.Create;
      if FileExists(dname) then
      begin
        fDso := TFileStream.Create(dname, fmOpenRead or fmShareDenyNone);
        fDso.Seek($134, 0);
        fDso.Read(dsostart, 4);
        fDso.Read(dsosize, 4);
        fDso.Seek(dsostart + 1, 0);
        SetLength(Temp, dsosize);
        fDso.Read(Temp[0], dsosize);
        while Temp[Length(Temp) - 1] = 0 do
          SetLength(Temp, Length(Temp) - 1);
        for b in Temp do
          if b > 0 then
            dsotemp := dsotemp + chr(b)
          else
            dsotemp := dsotemp + #13#10;
        SetLength(Temp, 0);
        sDso.Text := dsotemp;
        dsotemp := '';
        sDso.Delete(sDso.Count - 1);
        sDso.Delete(sDso.Count - 1);

        fDso.Free;
      end;
      FS.Seek(RomToOffset(expaddr), 0);
      for j := 1 to expnum do
      begin
        FS.Read(bufexp, 4);
        if bufexp <> 0 then
        begin
          dic[0] := i;
          dic[1] := j;
          dicM.AddOrSetValue(bufexp, dic);

          if bufexp = 0 then
            NamesArray.AddOrSetValue(
              { RomToOffset( } bufexp, StringGrid1.Rows[i][1]
                + '_absent_export_' + inttostr(j))
          else if j < sDso.Count + 1 then
            NamesArray.AddOrSetValue( { RomToOffset( } bufexp, sDso[j - 1])
          else
            NamesArray.AddOrSetValue(
              { RomToOffset( } bufexp, StringGrid1.Rows[i][1] + '_' + inttostr
                (j));
          inc(k);
          if k = 100 then
          begin
            Application.Processmessages;
            k := 0;
          end;
        end;
      end;
      sDso.Free;
    end;
    StringGrid1.Rows[i][4] := inttohex(expnum, 8);
  end;

  BitBtn4.Font.Color := clGreen;
  BitBtn4.Kind := bkOk;
  BitBtn4.Caption := 'Exports ready';
  BitBtn5.Enabled := True;
  BitBtn6.Enabled := True;
  BitBtn7.Enabled := True;
end;

procedure MakeIDC(num: Integer);
var
  Size, i, len: longint;
  buf, entry: dword;
  name: string;
  IDC: TStringList;
begin
  IDC := TStringList.Create;
  IDC.Add('#define UNLOADED_FILE   1');
  IDC.Add('#include <idc.idc>');
  IDC.Add('static main(void) {');
  FS.Seek(RomToOffset(StrToInt('$' + Form3.StringGrid1.Rows[num][3])), 0);
  FS.Seek($10, 1);
  FS.Read(entry, 4);
  FS.Seek($64, 1);
  Size := StrToInt('$' + Form3.StringGrid1.Rows[num][2]);
  len := FS.Position + Size;
  i := 0;
  while (FS.Position < len) and (FS.Position < FS.Size) do
  begin
    FS.Read(buf, 4);
    if buf = $E51FF004 then
    begin
      FS.Read(buf, 4);
      if NamesArray.TryGetValue( { RomToOffset( } buf, name) then
      begin
        if Copy(name, 1, 1) = '"' then
          name := StringReplace(name, '"', '', [rfReplaceAll]);
        IDC.Add(Format('MakeCode(0x%s);', [inttohex(FS.Position - 8 + romstart
              { RomToOffsetBase(entry) } , 8)]));
        IDC.Add(Format('MakeName(0x%s,"%s");',
            [inttohex(FS.Position - 8 + romstart
              { RomToOffsetBase(entry) } , 8), name]));
      end;
    end;
    inc(i);
    if i = 200 then
    begin
      Application.Processmessages;
      i := 0;
    end;
  end;
  if StrToInt('$' + Form3.StringGrid1.Rows[num][4]) > 0 then
  begin
    FS.Seek(RomToOffset(StrToInt('$' + Form3.StringGrid1.Rows[num][3])), 0);
    FS.Seek($40, 1);
    FS.Read(buf, 4);
    FS.Seek(RomToOffset(buf), 0);
    for i := 1 to StrToInt('$' + Form3.StringGrid1.Rows[num][4]) do
    begin
      FS.Read(buf, 4);
      if buf = 0 then
        IDC.Add(Format('RenameEntryPoint(%d,"%s");',
            [i, Form3.StringGrid1.Rows[num][1] + '_absent_export_' + inttostr(i)
              ]))
      else if NamesArray.TryGetValue( { RomToOffset( } buf, name) then
        IDC.Add(Format('RenameEntryPoint(%d,"%s");', [i, name]))
      else
        IDC.Add(Format('RenameEntryPoint(%d,"%s");',
            [i, Form3.StringGrid1.Rows[num][1] + '_' + inttostr(i)]))
    end;
  end;
  IDC.Add('}');
  IDC.SaveToFile(Form3.SaveDialog1.FileName);

  IDC.Free;
end;

procedure TForm3.BitBtn5Click(Sender: TObject);
var
  s: string;
begin
  SaveDialog1.FileName := StringGrid1.Rows[StringGrid1.Row][1] + '.idc';
  if SaveDialog1.Execute then
  begin
    if sgsel.Count = 0 then
      MakeIDC(StringGrid1.Row)
    else
      for s in sgsel do
      begin
        SaveDialog1.FileName := ExtractFilePath(SaveDialog1.FileName)
          + StringGrid1.Rows[StrToInt(s)][1] + '.idc';
        MakeIDC(StrToInt(s));
      end;
    Form3.BitBtn5.Caption := 'Done!';
    Delay(3000);
    Form3.BitBtn5.Caption := 'Make idc for selected';
  end;
end;

procedure TForm3.BitBtn6Click(Sender: TObject);
var
  fname: string;
  i: Integer;
begin
  SaveDialog1.FileName := StringGrid1.Rows[1][1];
  if SaveDialog1.Execute then
  begin
    fname := ExtractFilePath(SaveDialog1.FileName);
    BitBtn6.Enabled := False;
    BitBtn6.Caption := 'Processing...';
    for i := 1 to StringGrid1.RowCount - 1 do
    begin
      if i mod 100 = 0 then
        BitBtn6.Caption := Format('Processing [%d/%d] ...',
          [i, StringGrid1.RowCount - 1]);
      Application.Processmessages;
      SaveFile(fname + StringGrid1.Rows[i][1], i);
    end;
    BitBtn6.Enabled := True;
    BitBtn6.Caption := 'Done!';
    Delay(3000);
    BitBtn6.Caption := 'Extract all';
  end;
end;

procedure TForm3.BitBtn7Click(Sender: TObject);
var
  fname: string;
  i: Integer;
begin
  SaveDialog1.FileName := StringGrid1.Rows[1][1] + '.idc';
  if SaveDialog1.Execute then
  begin
    BitBtn7.Enabled := False;
    BitBtn7.Caption := 'Processing...';
    fname := ExtractFilePath(SaveDialog1.FileName);
    for i := 1 to StringGrid1.RowCount - 1 do
    begin
      if i mod 100 = 0 then
        BitBtn7.Caption := Format('Processing [%d/%d] ...',
          [i, StringGrid1.RowCount - 1]);
      Application.Processmessages;
      SaveDialog1.FileName := fname + StringGrid1.Rows[i][1] + '.idc';
      MakeIDC(i);
    end;

    BitBtn7.Enabled := True;
    BitBtn7.Caption := 'Done!';
    Delay(3000);
    BitBtn7.Caption := 'Make idc for all';
  end;
end;

procedure TForm3.BitBtn8Click(Sender: TObject);
var
  i: Integer;
  uid, startad, modulever, codesize, datasize, filesize: dword;
  arr: tDic;
begin

  Application.Processmessages;
  for i := 1 to StringGrid1.RowCount - 1 do
  begin
    FS.Seek(RomToOffset(StrToInt('$' + StringGrid1.Rows[i][3])), 0);
    FS.Seek(8, 1);
    FS.Read(uid, 4);
    FS.Seek(8, 1);
    FS.Read(startad, 4);
    FS.Seek(4, 1);
    FS.Read(codesize, 4);
    FS.Seek(4, 1);
    FS.Read(datasize, 4);
    filesize := codesize + datasize + $78;
    FS.Seek(72, 1);
    FS.Read(modulever, 4);

    arr[0] := StringGrid1.Rows[i][1];
    arr[1] := inttostr(startad);
    arr[2] := inttostr(startad + filesize);
    arr[3] := LowerCase(inttohex(modulever, 8));
    arr[4] := LowerCase(inttohex(uid, 8));
    arr[5] := StringGrid1.Rows[i][4];
    dicT.AddOrSetValue(i, arr);
  end;

  BitBtn8.Kind := bkOk;
  BitBtn8.Caption := 'Infodic ready';
  BitBtn8.Enabled := False;
  BitBtn9.Enabled := True;
  BitBtn11.Enabled := True;
  // CheckBox1.Visible := True;

  CheckBox3.Visible := True;
  Label4.Visible := True;
  Label5.Visible := True;
  Label7.Visible := True;
end;

function command_chk(addr: dword): Boolean;
begin
  Result := False;
  case addr and $FFFF of
    $B0B0:
      Result := True;
    $ABB0:
      Result := True;
    $AAB0:
      Result := True;
  end;
  case addr of
    $80068400:
      Result := True;
    $83A010FF:
      Result := True;
  end;
end;

Procedure Sort_Shell(var a: array of longint);
var
  bis, i, j, k: longint;
  h: Word;
begin
  bis := High(a);
  k := bis shr 1; // div 2
  while k > 0 do
  begin
    for i := 0 to bis - k do
    begin
      j := i;
      while (j >= 0) and (a[j] > a[j + k]) do
      begin
        h := a[j];
        a[j] := a[j + k];
        a[j + k] := h;
        if j > k then
          dec(j, k)
        else
          j := 0;
      end; // {end while]
    end; // { end for}
    k := k shr 1; // div 2
  end; // {end while}

end;

Procedure Sort_Bubble(var a: array of dword);
var
  changed: Boolean;
  i: longint;
  buf: dword;
begin
  repeat
    changed := False;
    for i := 0 to Length(a) - 2 do
      if a[i] < a[i + 1] then
      begin
        buf := a[i];
        a[i] := a[i + 1];
        a[i + 1] := buf;
        changed := True;
      end;
  until not changed;
end;

function CRC32(IniCRC: cardinal; Source: Pointer; len: cardinal): dword;
assembler;
asm
Push EBX
Push ESI
Push EDI
Or EDX,EDX
Jz @Done
Mov ESI,EDX
Jecxz @Done
Lea EDI,@CRCTbl
Mov EDX,EAX
Xor EAX,EAX
Cld
@L1:
Lodsb
Mov EBX,EDX
Xor EBX,EAX
And EBX,$FF
Shl EBX,2
Shr EDX,8
And EDX,$FFFFFF
Xor EDX,[EDI+EBX]
Dec ECX
Jnz @L1
Mov EAX,EDX
@Done:
Pop EDI
Pop ESI
Pop EBX
Ret
@CRCTbl:
 DD $00000000, $77073096, $ee0e612c, $990951ba
 DD $076dc419, $706af48f, $e963a535, $9e6495a3
 DD $0edb8832, $79dcb8a4, $e0d5e91e, $97d2d988
 DD $09b64c2b, $7eb17cbd, $e7b82d07, $90bf1d91
 DD $1db71064, $6ab020f2, $f3b97148, $84be41de
 DD $1adad47d, $6ddde4eb, $f4d4b551, $83d385c7
 DD $136c9856, $646ba8c0, $fd62f97a, $8a65c9ec
 DD $14015c4f, $63066cd9, $fa0f3d63, $8d080df5
 DD $3b6e20c8, $4c69105e, $d56041e4, $a2677172
 DD $3c03e4d1, $4b04d447, $d20d85fd, $a50ab56b
 DD $35b5a8fa, $42b2986c, $dbbbc9d6, $acbcf940
 DD $32d86ce3, $45df5c75, $dcd60dcf, $abd13d59
 DD $26d930ac, $51de003a, $c8d75180, $bfd06116
 DD $21b4f4b5, $56b3c423, $cfba9599, $b8bda50f
 DD $2802b89e, $5f058808, $c60cd9b2, $b10be924
 DD $2f6f7c87, $58684c11, $c1611dab, $b6662d3d
 DD $76dc4190, $01db7106, $98d220bc, $efd5102a
 DD $71b18589, $06b6b51f, $9fbfe4a5, $e8b8d433
 DD $7807c9a2, $0f00f934, $9609a88e, $e10e9818
 DD $7f6a0dbb, $086d3d2d, $91646c97, $e6635c01
 DD $6b6b51f4, $1c6c6162, $856530d8, $f262004e
 DD $6c0695ed, $1b01a57b, $8208f4c1, $f50fc457
 DD $65b0d9c6, $12b7e950, $8bbeb8ea, $fcb9887c
 DD $62dd1ddf, $15da2d49, $8cd37cf3, $fbd44c65
 DD $4db26158, $3ab551ce, $a3bc0074, $d4bb30e2
 DD $4adfa541, $3dd895d7, $a4d1c46d, $d3d6f4fb
 DD $4369e96a, $346ed9fc, $ad678846, $da60b8d0
 DD $44042d73, $33031de5, $aa0a4c5f, $dd0d7cc9
 DD $5005713c, $270241aa, $be0b1010, $c90c2086
 DD $5768b525, $206f85b3, $b966d409, $ce61e49f
 DD $5edef90e, $29d9c998, $b0d09822, $c7d7a8b4
 DD $59b33d17, $2eb40d81, $b7bd5c3b, $c0ba6cad
 DD $edb88320, $9abfb3b6, $03b6e20c, $74b1d29a
 DD $ead54739, $9dd277af, $04db2615, $73dc1683
 DD $e3630b12, $94643b84, $0d6d6a3e, $7a6a5aa8
 DD $e40ecf0b, $9309ff9d, $0a00ae27, $7d079eb1
 DD $f00f9344, $8708a3d2, $1e01f268, $6906c2fe
 DD $f762575d, $806567cb, $196c3671, $6e6b06e7
 DD $fed41b76, $89d32be0, $10da7a5a, $67dd4acc
 DD $f9b9df6f, $8ebeeff9, $17b7be43, $60b08ed5
 DD $d6d6a3e8, $a1d1937e, $38d8c2c4, $4fdff252
 DD $d1bb67f1, $a6bc5767, $3fb506dd, $48b2364b
 DD $d80d2bda, $af0a1b4c, $36034af6, $41047a60
 DD $df60efc3, $a867df55, $316e8eef, $4669be79
 DD $cb61b38c, $bc66831a, $256fd2a0, $5268e236
 DD $cc0c7795, $bb0b4703, $220216b9, $5505262f
 DD $c5ba3bbe, $b2bd0b28, $2bb45a92, $5cb36a04
 DD $c2d7ffa7, $b5d0cf31, $2cd99e8b, $5bdeae1d
 DD $9b64c2b0, $ec63f226, $756aa39c, $026d930a
 DD $9c0906a9, $eb0e363f, $72076785, $05005713
 DD $95bf4a82, $e2b87a14, $7bb12bae, $0cb61b38
 DD $92d28e9b, $e5d5be0d, $7cdcefb7, $0bdbdf21
 DD $86d3d2d4, $f1d4e242, $68ddb3f8, $1fda836e
 DD $81be16cd, $f6b9265b, $6fb077e1, $18b74777
 DD $88085ae6, $ff0f6a70, $66063bca, $11010b5c
 DD $8f659eff, $f862ae69, $616bffd3, $166ccf45
 DD $a00ae278, $d70dd2ee, $4e048354, $3903b3c2
 DD $a7672661, $d06016f7, $4969474d, $3e6e77db
 DD $aed16a4a, $d9d65adc, $40df0b66, $37d83bf0
 DD $a9bcae53, $debb9ec5, $47b2cf7f, $30b5ffe9
 DD $bdbdf21c, $cabac28a, $53b39330, $24b4a3a6
 DD $bad03605, $cdd70693, $54de5729, $23d967bf
 DD $b3667a2e, $c4614ab8, $5d681b02, $2a6f2b94
 DD $b40bbe37, $c30c8ea1, $5a05df1b, $2d02ef8d
end
;

  procedure TForm3.BitBtn9Click(Sender: TObject);
  var
    Knull: dword;

    fdata: tDic;
    ad_ofset, start_ad, end_ad, file_size, export_num: dword;

    uid1, uid2, uid3, uidcrc, xEntryPoint, xCodeAddress, iEntryPoint,
      iCodeBase, iDataBase, xDataAddress, iDataOffset, xCodeSize, iTextSize,
      xDataSize, xBssSize, iHeapSizeMin, iHeapSizeMax, iStackSize,
      xDllRefTable, iExportDirCount, xExportDir, iExportDirOffset, iSecureId,
      iVendorId, iSecurityCapsHi, iSecurityCapsLo, iToolsVersion, xFlags,
      iFlags, xPriority, iPriority, xDataBssLinearBase, iNextExtension,
      iHardwareVariant, iTotalDataSize, iModuleVersion, xExceptionDescriptor,
      iExceptionDescriptor, iExportDesc, iSpare2, xDllRef: dword;

    iFlag0, iFlag1, iFlag2, iFlag3: byte;

    Add, add_mod, fno, ad_minold, ad_maxold, ad_size: dword;
    fp, fp2, rlocbase, datarlocbase, fp0, i, k, last_rlocbase,
      last_datarlocbase: longint;
    fname, FileName: string;

    F: TMemoryStream;
    tempword: words;
    tempDicM: mDic;
    tempDicT: tDic;
    tempdword: dwords;

    dummy, DRTno: Integer;
    xtest: dword;

    codesec, importsec, relocsec, datarelocsec, header: TMemoryStream;
    outfile: TFileStream;

    importnum, importsize, n00, addnum: dword;
    xImportSize, iImportOffset, iDllRefTableCount: dword;
    adddata: array of dwords;
    import: dwords;
    fndata: array of AnsiString;

    relocsize, relocnum, relocn, relocs, xCodeRelocSize,
      iCodeRelocOffset: dword;
    relocbase, datarelocbase: longint;
    relocdata, datarelocdata: words;

    datarelocsize, datarelocnum, datarelocn, datarelocs, xDataRelocSize,
      iDataRelocOffset, iUncompressedSize: dword;

    CodeRelocSort, DataRelocSort: array of Integer;
    ImpSort: array of dword;
    iHeaderCrc: dword;

    ansiheader: AnsiString;
    bytesheader: TBytes;
    onebyte: byte;
    headercrc, signature, timelo, timehi, iCodeOffset: dword;

    code_relocs, data_relocs, last_code_relocs, last_data_relocs: longint;
    code_relocsize, code_relocs_size, data_relocsize, data_relocs_size: dword;
    code_reloc_savepos, data_reloc_savepos: int64;
    NullWord, code_reloc, data_reloc: Word;

    testboo: Word;
    s: string;

    log, fnames: TStringList;
  begin
    FileName := ExtractFilePath(OpenDialog1.FileName);

    if (sgsel.Count > 0) and (Sender <> nil) then
    begin
      for s in sgsel do
      begin
        StringGrid1.Row := StrToInt(s);
        BitBtn9Click(nil);
      end;

      BitBtn9.Caption := 'Done!';
      Delay(3000);
      BitBtn9.Caption := 'Convert selected to EPOC';

      exit;
    end;

    BitBtn9.Caption := 'Converting...';
    BitBtn9.Enabled := False;

    BitBtn1.Enabled := False;
    BitBtn2.Enabled := False;
    BitBtn6.Enabled := False;
    BitBtn5.Enabled := False;
    BitBtn7.Enabled := False;
    BitBtn11.Enabled := False;

    Memo1.Lines.Clear;
    fnames := TStringList.Create;
    log := TStringList.Create;

    dicRloc := TDictionary<longint, words>.Create;
    dicDataRloc := TDictionary<longint, words>.Create;
    dicImp := TDictionary<dword, dwords>.Create;

    signature := $434F5045;
    iHeaderCrc := $C90FDAA2;
    Knull := $00000000;
    NullWord := $0000;

    timelo := $6f526100;
    timehi := $0054416d;
    iCodeOffset := $0000009C;
    dicT.TryGetValue(StringGrid1.Row, fdata);

    ad_ofset := strtoint64(fdata[1]);
    start_ad := strtoint64(fdata[1]);
    end_ad := strtoint64(fdata[2]);
    file_size := end_ad - start_ad;
    export_num := strtoint64('$' + fdata[5]);

    log.Add('XIP modify of ' + fdata[0] + ' to E32image.');
    log.Add(Format('** start 0x%s -> end 0x%s', [inttohex(start_ad, 8), inttohex
          (end_ad - $78, 8)]));

    codesec := TMemoryStream.Create;

    F := TMemoryStream.Create;
    FS.Seek($8C, 0);
    FS.Read(ad_minold, 4);
    FS.Seek($F4, 0);
    FS.Read(ad_size, 4);
    ad_maxold := ad_minold + ad_size;
    FS.Seek(RomToOffset(StrToInt('$' + StringGrid1.Rows[StringGrid1.Row][3])),
      0);
    F.CopyFrom(FS, file_size + $78);
    F.Seek(0, 0);
    // **read ROMimage header info**
    F.Read(uid1, 4);
    F.Read(uid2, 4);
    F.Read(uid3, 4);
    F.Read(uidcrc, 4);
    F.Read(xEntryPoint, 4);
    F.Read(xCodeAddress, 4);
    iEntryPoint := xEntryPoint - xCodeAddress;
    iCodeBase := $8000;
    F.Read(xDataAddress, 4);
    if xDataAddress <> 0 then
      log.Add(Format('** DataAddress NOT 0x00!! %s', [inttohex(xDataAddress, 8)]
          ));
    iDataOffset := xDataAddress - xCodeAddress + $9C;
    F.Read(xCodeSize, 4);
    F.Read(iTextSize, 4);
    F.Read(xDataSize, 4);
    if xDataSize <> 0 then
    begin
      iDataBase := $400000;
      iDataOffset := xDataAddress - xCodeAddress + $9C;
      log.Add(Format('** DataSize NOT 0x00!! %s', [inttohex(xDataSize, 8)]));
    end
    else
    begin
      iDataBase := dword(0);
      iDataOffset := dword(0);
    end;
    F.Read(xBssSize, 4);
    if xBssSize <> 0 then
      log.Add(Format('** BssSize NOT 0x00!! %s', [inttohex(xBssSize, 8)]));
    F.Read(iHeapSizeMin, 4);
    F.Read(iHeapSizeMax, 4);
    F.Read(iStackSize, 4);
    F.Read(xDllRefTable, 4);
    F.Read(iExportDirCount, 4);
    F.Read(xExportDir, 4);
    iExportDirOffset := xExportDir - xCodeAddress + $9C;
    F.Read(iSecureId, 4);
    F.Read(iVendorId, 4);
    F.Read(iSecurityCapsHi, 4);
    F.Read(iSecurityCapsLo, 4);
    F.Read(iToolsVersion, 4);
    // F.Read(xFlags, 4);
    // iFlags := xFlags + $12000000;
    F.Read(iFlag0, 1);
    F.Read(iFlag1, 1);
    // iFlag1 := $02;
    F.Read(iFlag2, 1);
    iFlag2 := $00;
    F.Read(iFlag3, 1);
    iFlag3 := $12;
    // showmessage(inttohex( xFlags ,8));
    // showmessage(inttohex( iFlags ,8));
    F.Read(xPriority, 4);
    iPriority := xPriority + $20000000;
    F.Read(xDataBssLinearBase, 4);
    F.Read(iNextExtension, 4);
    F.Read(iHardwareVariant, 4);
    F.Read(iTotalDataSize, 4);
    F.Read(iModuleVersion, 4);
    F.Read(xExceptionDescriptor, 4);
    if xExceptionDescriptor > xCodeAddress then
      iExceptionDescriptor := xExceptionDescriptor - xCodeAddress + 1
    else
      iExceptionDescriptor := xExceptionDescriptor;
    iExportDesc := dword(0);
    iSpare2 := dword(0);
    // **modify CodeSection & DataSection**
    log.Add('FileTop+:CodeTop+:Replacement       :Comment');
    fp := $78;
    fp2 := $78;
    rlocbase := 0;
    datarlocbase := 0;

    relocsec := TMemoryStream.Create;
    relocsec.Write(Knull, 4);
    relocsec.Write(Knull, 4);
    relocsec.Write(rlocbase, 4);
    code_reloc_savepos := relocsec.Position;
    relocsec.Write(Knull, 4);

    datarelocsec := TMemoryStream.Create;
    // datarelocsec.SetSize(0);

    datarelocsec.Write(Knull, 4);
    datarelocsec.Write(Knull, 4);
    datarelocsec.Write(rlocbase, 4);
    data_reloc_savepos := datarelocsec.Position;
    datarelocsec.Write(Knull, 4);

    while fp < (xCodeSize + xDataSize + $78) do
    begin
      F.Seek(fp, 0);
      F.Read(Add, 4);
      fp0 := fp - $78;
      if fp0 >= (rlocbase + $1000) then
        rlocbase := rlocbase + $1000;
      if fp0 >= (datarlocbase + $1000 + xCodeSize) then
        datarlocbase := datarlocbase + $1000;
      if (Add >= start_ad) and (Add <= end_ad) then
      begin
        if fp0 < xCodeSize then
        begin
          add_mod := Add - ad_ofset + iCodeBase;
          if (rlocbase <> last_rlocbase) and (last_code_relocs <> code_relocs)
            then
          begin
            if relocsec.Size mod 4 <> 0 then
              relocsec.Write(NullWord, 2);
            relocsec.Seek(code_reloc_savepos, 0);
            code_relocsize := relocsec.Size - code_reloc_savepos + 4;
            relocsec.Write(code_relocsize, 4);
            relocsec.Seek(0, 2);

            if code_relocs = 0 then
              relocsec.Seek(-8, 1);

            relocsec.Write(rlocbase, 4);
            code_reloc_savepos := relocsec.Position;
            relocsec.Write(Knull, 4);
            last_rlocbase := rlocbase;
            last_code_relocs := code_relocs;
          end;
          inc(code_relocs);
          code_reloc := fp0 - rlocbase + $1000;
          relocsec.Write(code_reloc, 2);
        end { if fp0 < xCodeSize }
        else
        begin { if fp0 >= xCodeSize }
          add_mod := Add - ad_ofset + iCodeBase;
          if (datarlocbase <> last_datarlocbase) or
            (last_data_relocs <> data_relocs) then
          begin
            if datarelocsec.Size mod 4 <> 0 then
              datarelocsec.Write(NullWord, 2);
            datarelocsec.Seek(data_reloc_savepos, 0);
            data_relocsize := datarelocsec.Size - data_reloc_savepos + 4;
            datarelocsec.Write(data_relocsize, 4);
            datarelocsec.Seek(0, 2);

            if data_relocs = 0 then
              datarelocsec.Seek(-8, 1);

            datarelocsec.Write(datarlocbase, 4);
            data_reloc_savepos := datarelocsec.Position;
            datarelocsec.Write(Knull, 4);
            last_datarlocbase := datarlocbase;
            last_data_relocs := data_relocs;
          end;
          inc(data_relocs);
          data_reloc := fp0 - datarlocbase + $1000 - xCodeSize;
          datarelocsec.Write(data_reloc, 2);
        end; { if fp0 >= xCodeSize }
        log.Add(Format('%s:%s:%s->%s:Change Addr', [inttohex(fp, 8), inttohex
              (fp0, 8), inttohex(Add, 8), inttohex(add_mod, 8)]));
      end { if (add >= start_ad) and (add <= end_ad) }
      else if (fp0 >= xCodeSize) and (Add >= xDataBssLinearBase) and
        (Add <= xDataBssLinearBase + xDataSize + xBssSize) then
      begin
        add_mod := Add - xDataBssLinearBase + iDataBase;
        if (datarlocbase <> last_datarlocbase) or
          (last_data_relocs <> data_relocs) then
        begin
          if datarelocsec.Size mod 4 <> 0 then
            datarelocsec.Write(NullWord, 2);
          datarelocsec.Seek(data_reloc_savepos, 0);
          data_relocsize := datarelocsec.Size - data_reloc_savepos + 4;
          datarelocsec.Write(data_relocsize, 4);
          datarelocsec.Seek(0, 2);

          if data_relocs = 0 then
            datarelocsec.Seek(-8, 1);

          datarelocsec.Write(datarlocbase, 4);
          data_reloc_savepos := datarelocsec.Position;
          datarelocsec.Write(Knull, 4);
          last_datarlocbase := datarlocbase;
          last_data_relocs := data_relocs;
        end;
        inc(data_relocs);
        data_reloc := fp0 - datarlocbase + $2000 - xCodeSize;
        datarelocsec.Write(data_reloc, 2);
        log.Add(Format('%s:%s:%s->%s:Change Addr', [inttohex(fp, 8), inttohex
              (fp0, 8), inttohex(Add, 8), inttohex(add_mod, 8)]));
      end { if (fp0 >= xCodeSize) and (add >= xDataBssLinearBase) }
      else if dicM.ContainsKey(Add) then
      begin
        dicM.TryGetValue(Add, tempDicM);
        fno := tempDicM[0];
        dicT.TryGetValue(fno, tempDicT);
        fname := tempDicT[0];
        if (not command_chk(Add)) then
        begin
          add_mod := tempDicM[1];
          if dicImp.ContainsKey(fno) then
          begin
            dicImp.TryGetValue(fno, tempdword);
            SetLength(tempdword, Length(tempdword) + 1);
            tempdword[Length(tempdword) - 1] := fp0;
            dicImp.AddOrSetValue(fno, tempdword);
          end
          else
          begin
            SetLength(tempdword, 1);
            tempdword[0] := fp0;
            dicImp.AddOrSetValue(fno, tempdword);
          end; { if dicImp.ContainsKey(fno) }
          log.Add(Format('%s:%s:%s->%s:Change Port %s %d', [inttohex(fp, 8),
              inttohex(fp0, 8), inttohex(Add, 8), inttohex(add_mod, 8), fname,
              add_mod]));
          // if fnames.IndexOf(fname)<0 then
          // fnames.Add(fname);
        end { if not command_chk(add) }
        else
        begin { if command_chk(add) }
          add_mod := Add;
          log.Add(Format('%s:%s:%s Not change(SamePort %s %d)',
              [inttohex(fp, 8), inttohex(fp0, 8), inttohex(Add, 8), fname,
              tempDicM[1]]));
        end; { if command_chk(add) }
      end { if dicM.ContainsKey(add) }
      else if dicM.ContainsKey(Add - 8) then
      begin
        dicM.TryGetValue(Add - 8, tempDicM);
        fno := tempDicM[0];
        dicT.TryGetValue(fno, tempDicT);
        fname := tempDicT[0];
        // F.Seek(2, 1);
        // F.Read(testboo, 2);
        // F.Seek(-4, 1);
        if (not command_chk(Add))
        { or ((testboo <> $7fff) and (testboo <> $7ffe)) } then
        begin
          add_mod := tempDicM[1] + $80000;
          if dicImp.ContainsKey(fno) then
          begin
            dicImp.TryGetValue(fno, tempdword);
            SetLength(tempdword, Length(tempdword) + 1);
            tempdword[Length(tempdword) - 1] := fp0;
            dicImp.AddOrSetValue(fno, tempdword);
          end
          else
          begin
            SetLength(tempdword, 1);
            tempdword[0] := fp0;
            dicImp.AddOrSetValue(fno, tempdword);
          end; { if dicImp.ContainsKey(fno) }
          log.Add(Format('%s:%s:%s->%s:Change Port(offset by 8) %s %d',
              [inttohex(fp, 8), inttohex(fp0, 8), inttohex(Add, 8), inttohex
                (add_mod, 8), fname, tempDicM[1]]));
          // if fnames.IndexOf(fname)<0 then
          // fnames.Add(fname);
        end { if not command_chk(add) }
        else
        begin { if command_chk(add) }
          add_mod := Add;
          log.Add(Format('%s:%s:%s Not change(SamePort %s %d)',
              [inttohex(fp, 8), inttohex(fp0, 8), inttohex(Add, 8), fname,
              tempDicM[1]]));
        end; { if command_chk(add) }
      end { if dicM.ContainsKey(add-8) }
      else
      begin
        add_mod := Add;
        if (Add >= ad_minold) and (Add <= ad_maxold) and (not command_chk(Add))
          then
          log.Add(Format('%s:%s:%s Not change(Need check)', [inttohex(fp, 8),
              inttohex(fp0, 8), inttohex(Add, 8)]));
      end;
      codesec.Write(add_mod, 4);
      fp := fp + 4;
      fp2 := fp2 + 4;
      if fp2 > 256 then
      begin
        Application.Processmessages;
        fp2 := 0;
      end;
    end; { while fp < (xCodeSize = xDataSize + $78) }

    // **print out iDllRefTable info
    if xDllRefTable > 0 then
    begin
      F.Seek(2, 1);
      F.Read(DRTno, 2);
      // Memo1.Lines.Add(Format('**DllRefTable info : count = %d', [DRTno]));    //PrintOut Disabled
      for i := 1 to DRTno do
      begin
        F.Read(xDllRef, 4);
        // Memo1.Lines.Add(Format('   %08x', [xDllRef]));
      end;
    end;
    F.Free;

    { log.Add(Format('** Image using %d ROM libraries:', [fnames.Count]));

      for fname in fnames do
      log.Add(fname); }

    fnames.Free;

    // **rebuild ImportSection**
    importnum := 0;
    importsize := 4;
    for fno in dicImp.Keys do
    begin
      SetLength(ImpSort, Length(ImpSort) + 1);
      ImpSort[Length(ImpSort) - 1] := fno;
    end;
    Sort_Bubble(ImpSort);
    for fno in ImpSort do
    begin
      addnum := Length(dicImp[fno]);
      importsize := importsize + (addnum + 2) * 4;
      SetLength(import, addnum + 1);
      import[0] := addnum;
      for i := 0 to addnum - 1 do
        import[i + 1] := dicImp[fno][i];

      SetLength(adddata, Length(adddata) + 1);
      adddata[Length(adddata) - 1] := import;

      SetLength(fndata, Length(fndata) + 1);
      fndata[Length(fndata) - 1] := Copy
        (dicT[fno][0], 1, Length(dicT[fno][0]) - 4) + '{' + dicT[fno][3] + '}';
      if dicT[fno][4] <> '00000000' then
        fndata[Length(fndata) - 1] := fndata[Length(fndata) - 1] + '[' + dicT
          [fno][4] + ']';
      fndata[Length(fndata) - 1] := fndata[Length(fndata) - 1] + ExtractFileExt
        (dicT[fno][0]) + chr(0);
      inc(importnum);
    end;
    iDllRefTableCount := importnum;
    importsec := TMemoryStream.Create;
    importsec.Write(Knull, 4);
    for i := 0 to importnum - 1 do
    begin
      importsec.Write(importsize, 4);
      for k := 0 to Length(adddata[i]) - 1 do
        importsec.Write(adddata[i][k], 4);
      importsize := importsize + Length(fndata[i]);
    end;
    n00 := importsize mod 4;
    xImportSize := importsize;
    if n00 <> 0 then
    begin
      n00 := 4 - n00;
      xImportSize := xImportSize + n00;
      for i := 1 to n00 do
        fndata[Length(fndata) - 1] := fndata[Length(fndata) - 1] + chr(0);
    end;
    for i := 0 to Length(fndata) - 1 do
      importsec.Write(fndata[i][1], Length(fndata[i]));
    importsec.Seek(0, 0);
    importsec.Write(importsize, 4);
    iImportOffset := xCodeSize + xDataSize + $9C;

    if code_relocs = 0 then
    begin
      relocsec.SetSize(0);
      relocsec.Clear;
      xCodeRelocSize := 0;
      iCodeRelocOffset := dword(0);
    end
    else
    begin
      if (rlocbase <> last_rlocbase) or (last_code_relocs <> code_relocs) then
      begin
        if relocsec.Size mod 4 <> 0 then
          relocsec.Write(NullWord, 2);
        relocsec.Seek(code_reloc_savepos, 0);
        code_relocsize := relocsec.Size - code_reloc_savepos + 4;
        relocsec.Write(code_relocsize, 4);
      end;

      relocsec.Seek(0, 0);
      code_relocs_size := relocsec.Size - 8;
      relocsec.Write(code_relocs_size, 4);
      relocsec.Write(code_relocs, 4);

      xCodeRelocSize := relocsec.Size;
      iCodeRelocOffset := xCodeSize + xDataSize + xImportSize + $9C;
    end;

    if data_relocs = 0 then
    begin
      datarelocsec.SetSize(0);
      datarelocsec.Clear;
      xDataRelocSize := 0;
      iDataRelocOffset := dword(0);
    end
    else
    begin
      if (datarlocbase <> last_datarlocbase) or
        (last_data_relocs <> data_relocs) then
      begin
        if datarelocsec.Size mod 4 <> 0 then
          datarelocsec.Write(NullWord, 2);
        datarelocsec.Seek(data_reloc_savepos, 0);
        data_relocsize := datarelocsec.Size - data_reloc_savepos + 4;
        datarelocsec.Write(data_relocsize, 4);
      end;

      datarelocsec.Seek(0, 0);
      data_relocs_size := datarelocsec.Size - 8;
      datarelocsec.Write(data_relocs_size, 4);
      datarelocsec.Write(data_relocs, 4);

      xDataRelocSize := datarelocsec.Size;
      iDataRelocOffset := xCodeSize + xDataSize + xImportSize +
        xCodeRelocSize + $9C;
    end;

    iUncompressedSize := xCodeSize + xDataSize + xImportSize + xCodeRelocSize +
      xDataRelocSize;
    header := TMemoryStream.Create;
    header.Write(uid1, 4);
    header.Write(uid2, 4);
    header.Write(uid3, 4);
    header.Write(uidcrc, 4);
    header.Write(signature, 4);
    header.Write(iHeaderCrc, 4);
    header.Write(iModuleVersion, 4);
    header.Write(Knull, 4);
    header.Write(iToolsVersion, 4);
    header.Write(timelo, 4);
    header.Write(timehi, 4);
    header.Write(iFlag0, 1);
    header.Write(iFlag1, 1);
    header.Write(iFlag2, 1);
    header.Write(iFlag3, 1);
    header.Write(xCodeSize, 4);
    header.Write(xDataSize, 4);
    header.Write(iHeapSizeMin, 4);
    header.Write(iHeapSizeMax, 4);
    header.Write(iStackSize, 4);
    header.Write(xBssSize, 4);
    header.Write(iEntryPoint, 4);
    header.Write(iCodeBase, 4);
    header.Write(iDataBase, 4);
    header.Write(iDllRefTableCount, 4);
    header.Write(iExportDirOffset, 4);
    header.Write(iExportDirCount, 4);
    header.Write(iTextSize, 4);
    header.Write(iCodeOffset, 4);
    header.Write(iDataOffset, 4);
    header.Write(iImportOffset, 4);
    header.Write(iCodeRelocOffset, 4);
    header.Write(iDataRelocOffset, 4);
    header.Write(iPriority, 4);
    header.Write(iUncompressedSize, 4);
    header.Write(iSecureId, 4);
    header.Write(iVendorId, 4);
    header.Write(iSecurityCapsHi, 4);
    header.Write(iSecurityCapsLo, 4);
    header.Write(iExceptionDescriptor, 4);
    header.Write(iSpare2, 4);
    header.Write(iExportDesc, 4);
    header.Seek(0, 0);
    SetLength(bytesheader, $9C);
    header.Read(bytesheader[0], $9C);
    headercrc := CRC32(0, bytesheader, $9C);
    header.Seek($14, 0);
    header.Write(headercrc, 4);
    header.Seek(0, 0);
    codesec.Seek(0, 0);
    importsec.Seek(0, 0);
    relocsec.Seek(0, 0);
    datarelocsec.Seek(0, 0);

    if CheckBox1.Checked then
    begin
      header.SaveToFile(FileName + StringGrid1.Rows[StringGrid1.Row][1]
          + '.header');
      codesec.SaveToFile(FileName + StringGrid1.Rows[StringGrid1.Row][1]
          + '.codesec');
      importsec.SaveToFile(FileName + StringGrid1.Rows[StringGrid1.Row][1]
          + '.importsec');
      relocsec.SaveToFile(FileName + StringGrid1.Rows[StringGrid1.Row][1]
          + '.relocsec');
      datarelocsec.SaveToFile(FileName + StringGrid1.Rows[StringGrid1.Row][1]
          + '.datarelocsec');
    end;
    outfile := TFileStream.Create
      (FileName + StringGrid1.Rows[StringGrid1.Row][1] + '.epoc',
      fmCreate or fmOpenWrite);
    outfile.CopyFrom(header, header.Size);
    outfile.CopyFrom(codesec, codesec.Size);
    outfile.CopyFrom(importsec, importsec.Size);
    outfile.CopyFrom(relocsec, relocsec.Size);
    outfile.CopyFrom(datarelocsec, datarelocsec.Size);
    outfile.Free;

    log.SaveToFile(FileName + StringReplace
        (StringGrid1.Rows[StringGrid1.Row][1] + '_XIP2EPOC_' + TimeToStr(now)
          + '.log', ':', '.', [rfReplaceAll]));

    if (CheckBox3.Checked) and (sgsel.Count = 0) then
    begin
      Memo1.Lines := log;

      StringGrid1.Height := 129;
      StringGrid1.Anchors := StringGrid1.Anchors - [akBottom];
      StringGrid1.TopRow := StringGrid1.Row;
      Memo1.Visible := True;

      BitBtn10.Visible := True;
      BitBtn12.Visible := True;
    end;

    log.Free;

    datarelocsec.Free;
    relocsec.Free;
    importsec.Free;
    codesec.Free;
    header.Free;

    dicRloc.Free;
    dicDataRloc.Free;
    dicImp.Free;

    BitBtn1.Enabled := True;
    BitBtn2.Enabled := True;
    BitBtn6.Enabled := True;
    BitBtn5.Enabled := True;
    BitBtn7.Enabled := True;
    BitBtn11.Enabled := True;

    BitBtn9.Enabled := True;
    if sgsel.Count = 0 then
    begin
      BitBtn9.Caption := 'Done!';
      Delay(3000);
      BitBtn9.Caption := 'Convert selected to EPOC';
    end;
  end;

  procedure sgFindText(Grid: TStringGrid; const Text: String;
    FindOptions: TFindOptions);
  var
    What, Where: String;
    i: Integer;
  begin
    What := AnsiLowerCase(Text);
    with Grid do
      for i := 1 to RowCount - 1 do
      begin
        Where := Cells[1, i];
        if What = '' then
          Row := 1
        else if Pos(What, Where) = 1 then
        begin
          Row := i;
          TopRow := i;
          break;
        end;
      end; { with }
  end;

  procedure TForm3.Edit1Change(Sender: TObject);
  var
  focus: TRect;
  begin
    sgFindText(StringGrid1, Edit1.Text, []);
  end;

  procedure TForm3.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
//
end;

procedure TForm3.FormCreate(Sender: TObject);
  begin
    StringGrid1EndDock(nil, nil, 0, 0);
    NamesArray := TDictionary<longint, string>.Create;
    dicT := TDictionary<Integer, tDic>.Create;
    dicM := TDictionary<dword, mDic>.Create;
    sgsel := TStringList.Create;

    DragAcceptFiles(Handle, True);

    if paramcount > 0 then
    begin
      LoadDump(paramstr(1));
      BitBtn4Click(nil);
      BitBtn3Click(nil);
      BitBtn8Click(nil);
    end;
  end;

  procedure TForm3.FormDestroy(Sender: TObject);
  begin
    FS.Free;
    NamesArray.Free;
    dicT.Free;
    dicM.Free;
    sgsel.Free;
  end;

  procedure TForm3.FormResize(Sender: TObject);
  begin
    StringGrid1.ColWidths[1] := ClientWidth - 404;
  end;

  procedure TForm3.Selectall1Click(Sender: TObject);
  begin
    Memo1.SelectAll;
  end;

  procedure TForm3.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
    Rect: TRect; State: TGridDrawState);
  var
    focus: TRect;
  begin
    if StringGrid1.Cells[0, ARow] = ' v' then
    begin
      StringGrid1.Canvas.Brush.Color := clGreen;
      StringGrid1.Canvas.Font.Color := clWhite;
    end
    else
    begin
      StringGrid1.Canvas.Brush.Color := clWhite;
      StringGrid1.Canvas.Font.Color := clBlack;
    end;

    if (aRow = StringGrid1.Row) then
    begin
      StringGrid1.Canvas.Brush.Color := clYellow;
      StringGrid1.Canvas.Font.Color := clBlack;
    end;

    StringGrid1.Canvas.fillRect(Rect);
    StringGrid1.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2, StringGrid1.Cells[ACol, ARow]);

  end;

  procedure TForm3.StringGrid1EndDock(Sender, Target: TObject; X, Y: Integer);
  begin
    StringGrid1.RowCount := 2;
    StringGrid1.Rows[1].Clear;
    StringGrid1.ColWidths[0] := 20;
    StringGrid1.ColWidths[1] := ClientWidth - 404;
    StringGrid1.Cells[1, 0] := 'Name';
    StringGrid1.Cells[2, 0] := 'Size';
    StringGrid1.Cells[3, 0] := 'Address';
    StringGrid1.Cells[4, 0] := 'Exports';
  end;

  procedure TForm3.StringGrid1KeyPress(Sender: TObject; var Key: Char);
  var
  b: string;
begin
    if Key = #$20 then
    begin
      if StringGrid1.Cells[0, StringGrid1.Row] = ' ' then
      begin
        StringGrid1.Cells[0, StringGrid1.Row] := ' v';
        sgsel.Add(inttostr(StringGrid1.Row));
      end
      else
      begin
        StringGrid1.Cells[0, StringGrid1.Row] := ' ';
        sgsel.Delete(sgsel.IndexOf(inttostr(StringGrid1.Row)));
      end;
      if sgsel.Count > 0 then
        BitBtn13.Visible := True
      else
        BitBtn13.Visible := False;
      StringGrid1.Repaint;
    end else
    if not (key in [#$25..#$28]) then
    begin
//      showmessage(inttostr(ord(key)));
      if key=#8 then
      begin
        if Length(Edit1.Text)>0 then
        begin
          b := Edit1.Text;
          SetLength(b, Length(b) - 1);
          Edit1.Text := b;
        end
      end
      else
        if key in ['-', '_', '(', ')', '.', '0'..'9', 'a'..'z', 'A'..'Z'] then
          Edit1.Text := Edit1.Text + Key;

    end;

end;

procedure TForm3.StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
    ARow, ACol: Integer;
  begin
    StringGrid1.MouseToCell(X, Y, ACol, ARow);
    if ACol = 0 then
    begin
      if StringGrid1.Cells[ACol, ARow] = ' ' then
      begin
        StringGrid1.Cells[ACol, ARow] := ' v';
        sgsel.Add(inttostr(ARow));
      end
      else
      begin
        StringGrid1.Cells[ACol, ARow] := ' ';
        sgsel.Delete(sgsel.IndexOf(inttostr(ARow)));
      end;
      if sgsel.Count > 0 then
        BitBtn13.Visible := True
      else
        BitBtn13.Visible := False;
      StringGrid1.Repaint;
    end;

end;

procedure TForm3.WMDropFiles(var Msg: TWMDropFiles);

  { Drkb v.3(2007): www.drkb.ru,
    Vit (Vitaly Nevzorov) - nevzorov@yahoo.com }

  var
    CFileName: array [0 .. MAX_PATH] of Char;
  begin
    try
      If DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
      begin
        Application.BringToFront;
        if Application.MessageBox('You really want to open new RomDump?',
          'Open new RomDump', MB_YESNO) = IDYES then
        begin
          NamesArray.Clear;
          dicT.Clear;
          dicM.Clear;

          LoadDump(CFileName);
          BitBtn4Click(nil);
          BitBtn3Click(nil);
          BitBtn8Click(nil);

          Msg.Result := 0;
        end;
      end;
    finally
      DragFinish(Msg.Drop); //  
    end;
  end;

end.
